<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from dependence.texi on 28 April 1999 -->

<TITLE>The DEPENDENCE Library - Detailed Description</TITLE>
<link href="dependence_2.html" rel=Previous>
<link href="dependence_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="dependence_1.html">first</A>, <A HREF="dependence_2.html">previous</A>, next, last section, <A HREF="dependence_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC3" HREF="dependence_toc.html#TOC3">Detailed Description</A></H1>

<P>
<CODE>fill_in_access(tree_proc * tp)</CODE>: annotates code in the given
tree_proc with <CODE>dep_instr_annote</CODE> and <CODE>dep_for_annote</CODE>.  These
annotations store information needed by the dependence analyzer.
<CODE>fill_in_access</CODE> must be run before any calls to <CODE>DependenceTest</CODE>.

</P>
<P>
<CODE>enum deptest_result {dt_none, dt_ok, dt_indep, dt_no_common_nest,
dt_too_messy}</CODE>: When <CODE>DependenceTest</CODE> is called with a
<CODE>deptest_result</CODE> pointer, the pointer will be assigned one of these
five values.  <CODE>dt_none</CODE> indicates that no dependence test was run.
<CODE>dt_ok</CODE> means that the two array accesses are data dependent, and
the corresponding dependence vectors are returned by
<CODE>DependenceTest</CODE>.  Returning <CODE>dt_indep</CODE> conveys that the two
array accesses are independent, and returning <CODE>dt_no_common_nest</CODE>
indicates the accesses have no common enclosing loop.  Lastly,
<CODE>dt_too_messy</CODE> suggests that the array access function was too messy,
thus beyond the scope of the dependence analyzer.

</P>
<P>
<CODE>dvlist * DependenceTest(in_array *w, in_array *r, int lexpos,
deptest_result * res)</CODE>: Function <CODE>DependenceTest</CODE> tests whether the
two array accesses <CODE>(*w &#38; *r)</CODE> are data dependent.  In particular,
it tests whether <CODE>*w</CODE> is data dependent on <CODE>*r</CODE>.  If <CODE>*w</CODE>
is indeed dependent on <CODE>*r</CODE>, <CODE>dt_ok</CODE> would be assigned to
<CODE>*res</CODE>.  Otherwise, <CODE>*res</CODE> would be given a value other than
<CODE>dt_ok</CODE>. See above for other <CODE>deptest_result</CODE> values.  When
the two accesses are data dependent, <CODE>DependenceTest</CODE> returns a
list of dependence vectors.  If <CODE>lexpos</CODE> is set, the list of
dependence vectors would only contain lexicographically positive
dependence vectors.

</P>
<P>
<CODE>dvlist * DependenceTest(in_array *w, in_array *r, deptest_result *
res)</CODE>: Calling this function is equivalent to calling
<CODE>DependenceTest(in_array *w, in_array *r, int lexpos, deptest_result *
res)</CODE> with <CODE>lexpos = 1</CODE>.

</P>
<P>
<CODE>dvlist * DependenceTest(in_array *w, in_array *r, int lexpos)</CODE>:
Calling this function is the same as calling
<CODE>DependenceTest(in_array *w, in_array *r, int lexpos,
deptest_result * res)</CODE> except no <CODE>deptest_result</CODE> is returned
through the <CODE>deptest_result</CODE> pointer.

</P>
<P>
<CODE>dvlist * DependenceTest(in_array *w, in_array *r)</CODE>: Calling this
function is equivalent to calling <CODE>DependenceTest(in_array *w,
in_array *r, int lexpos)</CODE> with <CODE>lexpos = 1</CODE>.

</P>
<P>
void <CODE>print_array_access(in_array * in, FILE * fs = stdout)</CODE>: print
the array access <CODE>*in</CODE> to file <CODE>*fs</CODE>.

</P>

<PRE>
class dvlist
    int indep();
    dvlist_e *pop();
    void print(FILE *);
</PRE>

<P>
A dvlist is used to store a list of dependence vectors.  Method
<CODE>indep</CODE> returns <CODE>TRUE</CODE> only if the corresponding array
accesses are independent.  Method <CODE>pop</CODE> returns the first element
of the list of dependence vectors as a <CODE>dvlist_e</CODE>.  Lastly, the
<CODE>print</CODE> method is provided for class <CODE>dvlist</CODE> for outputing
the list to a file.

</P>

<PRE>
class dvlist_iter
	dvlist_iter(dvlist *dv);
	dvlist_e *step();
	int is_empty()
</PRE>

<P>
A <CODE>dvlist_iter</CODE> is an iterator for class <CODE>dvlist</CODE>.  Once an
iterator is created for a specific <CODE>dvlist *dv</CODE> (using
<CODE>dvlist_iter(dv)</CODE>), the methods <CODE>step</CODE>, <CODE>next</CODE>,
<CODE>is_empty</CODE>, etc.  can be used to look at the elements of the list
(also see documentation for <CODE>glist_iter</CODE> in the SUIF Library
Reference Manual).

</P>

<PRE>
class dvlist_e
    distance_vector * dv;
</PRE>

<P>
Each element of a <CODE>dvlist</CODE> is a <CODE>dvlist_e</CODE>, and a
<CODE>dvlist_e</CODE> simply contains a dependence vector represented by the
class <CODE>distance_vector</CODE>.

</P>

<PRE>
class distance_vector
    distance_vector_e *pop()
    indep();
    void print(FILE *);
    is_empty()
    int is_zero();			/* is the vector 0? */
    int is_pos();			/* is first entry positive? */
    int is_neg();			/*                negative? */
    int is_star();			/*                star? */ 
    int level();			/* what is the level of this dep? */
    int size();			/* how big is the dvector? */
    distance *thresh(int level);     /* what is the threshold? must be # */
    void negate();			/* negate all of the distances */
    int first_not_eq();		/* level of the first non-= or * */
    /*   if all =, returns 0 */
    int operator==(distance_vector &#38;); /* if two vectors identical */
    int operator!=(distance_vector &#38;d);
</PRE>

<P>
A dependence vector is represented by class <CODE>distance_vector</CODE> which
is a list of <CODE>distance_vector_e</CODE>.  The length of the vector can be
obtained by calling the method <CODE>size</CODE>.  The elements of the list
can be extracted from the list using the <CODE>pop</CODE> method, and the
<CODE>is_empty</CODE> method tests whether all the elements have been removed.
Of course, one can also instantiate an iterator for looking at the list.
Some other useful methods are: <CODE>indep</CODE> returns TRUE if the
corresponding array accesses are independent, <CODE>level</CODE> returns the
dependence level, <CODE>first_not_eq</CODE> returns the level of the first
non-zero component, <CODE>negate</CODE> simply reverses the sign of all the
components, and <CODE>print</CODE> outputs the dependence vector to a file.
Operators <CODE>==</CODE> and <CODE>!=</CODE> are provided for comparing dependence
vectors, and methods <CODE>is_zero</CODE>, <CODE>is_pos</CODE>, <CODE>is_neg</CODE>,
<CODE>is_star</CODE> respectively test whether the distance_vector is a zero
vector, a lexicographically positive vector, a lexicographically
negative vector, or a vector with the star direction as its first entry.

</P>

<PRE>
class distance_vector_e
    distance d;
    int is_zero();
};
</PRE>

<P>
Each element of a <CODE>distance_vector</CODE> is a <CODE>distance_vector_e</CODE>,
and a <CODE>distance_vector_e</CODE> contains a distance, a component of a
dependence vector.  A method <CODE>is_zero</CODE> is provided to test whether
the distance is zero.

</P>

<PRE>
enum direction {d_lt=1,d_gt=2,d_eq=4,d_le=5,d_ge=6,d_lg=3,d_star=7};
</PRE>

<P>
Each component of a dependence vector can be summarized by one of seven
directions.  <CODE>d_lt</CODE> represents <CODE>&#60;</CODE>, <CODE>d_gt</CODE> represents
<CODE>&#62;</CODE>, <CODE>d_eq</CODE> represents <CODE>=</CODE>, <CODE>d_le</CODE> represents
<CODE>&#60;=</CODE>, <CODE>d_ge</CODE> represents <CODE>&#62;=</CODE>, <CODE>d_lg</CODE> represents
<CODE>&#60;&#62;</CODE> and <CODE>d_star</CODE> represents <CODE>*</CODE>.

</P>

<PRE>
class distance 
    int is_const();
    int dist();
    direction dir();
    int is_star();
    int has_eq();
    void print(FILE *);
    int is_zero();
    void negate();			/* negate the distance */
    int operator ==(distance &#38;d)
    int operator !=(distance &#38;d)
</PRE>

<P>
Each component of a dependence vector (represented by class
<CODE>distance_vector</CODE>) is a distance.  An object of type distance
contains a direction, and can be obtained by calling the method
<CODE>dir</CODE>.  In addition, if a numeric value is known, the object also
stores the integer value.  If an object of type <CODE>distance</CODE> contains
an integer value, a call to <CODE>is_const</CODE> would return TRUE and a call
to method <CODE>dist</CODE> would return the integer value.  Similarly,
methods <CODE>is_zero</CODE> and <CODE>is_star</CODE> test whether an object is
respectively the direction <CODE>d_eq</CODE> and the direction <CODE>d_star</CODE>.
Method <CODE>has_eq</CODE> returns TRUE if the object contains a direction
including <CODE>d_eq</CODE>, i.e. <CODE>d_eq</CODE>, <CODE>d_le</CODE>, <CODE>d_ge</CODE> and
<CODE>d_star</CODE>.  Furthermore, a few helpful mthods are provided for
class <CODE>distance</CODE>.  For example, operators <CODE>==</CODE> and <CODE>!=</CODE>
are provided to compare objects of type <CODE>distance</CODE>.  The method
<CODE>negate</CODE> is provided to negate a distance and method <CODE>print</CODE> to
output the distance to a file.

</P>

<P><HR><P>
<p>Go to the <A HREF="dependence_1.html">first</A>, <A HREF="dependence_2.html">previous</A>, next, last section, <A HREF="dependence_toc.html">table of contents</A>.
</BODY>
</HTML>
